import random

import pytest

import unit_converter


@pytest.fixture(scope="module")
def batch_numbers():
    return [random.random() * 100 for x in range(1000)]
    # The larger the range of numbers, the closer the Rust version is to Python.
    # e.g. return [random.random() * 100 for x in range(1000000)]


def batch_python_unit_converter(temperatures):
    return [celsius * 1.8 + 32.0 for celsius in temperatures]


def test_using_python_batch(benchmark, batch_numbers):
    benchmark(batch_python_unit_converter, batch_numbers)


def test_using_rust_batch(benchmark, batch_numbers):
    benchmark(unit_converter.batch_convert_to_fahrenheit, batch_numbers)
